/*                                                                          
  Ŀ
   Ejemplo2.c                                                             
                                                                          
   Ejemplo de utilizacin de las nuevas rutinas adaptadas para VScreens.  
                                                                          
   Compilado con :  Borland C/C++ v3.1                                    
   Cdigo y texto:  [NoP] de Compiler SoftWare.                     
                                                                          
   En este ejemplo se utiliza la constante VGASEG definida en MODE13H.H   
   y cuyo valor es 0xA000 (la direccin del segmento de VideoRAM).        
                                                                          
  1997 C.S.
*/

#include <stdio.h>               /* funciones estndar Input/Output */
#include <dos.h>                 /* funcin pokeb(); */
#include <conio.h>               /* funcin getch(); */
#include "libs\ints.h"           /* librera funciones varias int 10h */
#include "libs\mode13h.h"        /* librera funciones 320x200x256 */
#include "libs\vscreen.h"        /* librera pantallas virtuales */

unsigned int bucle, vscreen;

/*  Funcin principal main()  */

void main( void )
{

 SetVideoMode( 3 );                       /* inicializar 80x25x16 (3h) */

 printf("EJEMPLO2.EXE\r\n");
 printf("\r\nEn este ejemplo asignamos memoria para una pantalla virtual, escribimos\r\n");
 printf("en VRAM, y copiamos la VRAM sobre la VScreen. A continuacin borramos la\r\n");
 printf("pantalla y tras pulsar una tecla volcamos la VScreen sobre la VRAM, obte-\r\n");
 printf("niendo la imagen original instantneamente.\r\n\n");
 
 printf("Pulse cualquier tecla para realizar la prueba...");
 getch();

 SetVideoMode( 0x13 );                    /* inicializar 320x200x256 (13h) */
 
 vscreen = AllocateVScreen();             /* asignar pantalla virtual */
 if( vscreen == 0 )
  {
    SetVideoMode(3);
    printf("\a\r\nError liberando memoria para la VScreen.\r\n");
    return;
  }
 
 ClearScreen( 1, VGASEG );                /* limpiar videoram con color 1 */

 for( bucle=0; bucle<255; bucle++ )
   DrawVLine( bucle, 0, 100, bucle, VGASEG );

 PutPixel( 160, 140, 14, VGASEG );
 DrawHLine( 0, 199, 160, 15, VGASEG );

 FlipVScreen( VGASEG, vscreen );          /* copiamos VRAM->vscreen */

 getch();                                 /* esperar a que pulse una tecla */
 ClearScreen( 0, VGASEG );                /* borramos la pantalla VRAM */
 getch();                                 /* esperar a que pulse una tecla */
 FlipVScreen( vscreen, VGASEG );          /* copiamos vscreen->VRAM */
 getch();                                 /* esperar a que pulse una tecla */

 
 SetVideoMode( 3 );                       /* inicializar 80x25x16 (3h) */
 FreeVScreen( vscreen );                  /* liberamos memoria asignada */
}
