/*                                                                          
  Ŀ
   Ejemplo6.c                                                             
                                                                          
   Demostracin de pantallas virtuales, bitmaps, y sprites.               
                                                                          
   Compilado con :  Borland C/C++ v3.1                                    
   Cdigo y texto:  [NoP] de Compiler SoftWare.                     
  1997 C.S.
*/

#include <stdio.h>                  /* funciones estndar Input/Output */
#include <stdlib.h>                 /* funcin exit() */
#include <dos.h>                    /* funcin pokeb(); */
#include <conio.h>                  /* funcin getch(); */
#include "libs\ints.h"              /* librera funciones varias int 10h */
#include "libs\mode13h.h"           /* librera funciones 320x200x256 */
#include "libs\palette.h"           /* librera funciones paleta */
#include "libs\sprites.h"           /* librera funciones sprites */
#include "libs\vscreen.h"           /* librera funciones pant. virtuales */
#include "libs\mouse.h"             /* Funciones simples de uso del ratn */

#include "graphics\cursores.h"      /* bitmaps de 2 cursores */
#include "graphics\botones.h"       /* bitmaps de 2 botones */

void LoadImage( char * );           /* carga de un fichero SCR */

char fondo[ancho_cursor*alto_cursor];
unsigned int bucle, vscreen;
int x, y, exitbutton;

/*  Funcin principal main()  */

void main( void )
{

 SetVideoMode( 3 );                       /* inicializar 80x25x16 (3h) */

 if ( MouseOn() == 0 )                   /* inicializar ratn */
  {
    SetVideoMode(3);
    printf("\a\r\nDriver del ratn no encontrado en memoria...\r\n");
    return;
  }

 printf("EJEMPLO6.EXE\r\n");
 printf("\r\nEste ejemplo demuestra el uso de todos los elementos de los ejemplos ante-\r\n");
 printf("riores controlando un sprite con el ratn y esperando un evento (pulsacin).\r\n");
 printf("Necesitar tener cargado el driver del ratn para ejecutar el programa.\r\n\n");

 printf("Pulse cualquier tecla para realizar la prueba...");
 getch();
  
 vscreen = AllocateVScreen();              /* asignar pantalla virtual */
 if( vscreen == 0 )
  {
    SetVideoMode(3);
    printf("\a\r\nError liberando memoria para la VScreen.\r\n");
    return;
  }

 SetVideoMode( 0x13 );                    /* inicializar 320x200x256 (13h) */
 LoadImage("GRAPHICS\\IMAGE1.SCR");       /* cargamos la imagen de fondo */
 
 DrawSprite( 247, 172, ancho_boton, alto_boton, Boton1, VGASEG );
 FlipVScreen( VGASEG, vscreen );          /* guardamos el fondo en vscreen */

 exitbutton = 0;
 
 while( exitbutton == 0 )
 {
  GetXY( &x, &y );                           /* cogemos la (x,y) del ratn */
  x = x/2;                                   /* adaptamos x a 320x200 */
  
 /* gestin de sprites: comprobacin de coordenadas (no salga de pant.) */
  if( x>319-ancho_cursor ) x = 319-ancho_cursor;
  if( y>199-alto_cursor )  y = 199-alto_cursor;

 /* gestin de sprites: si estamos en el botn cambiamos el sprite */
 /* es un ejemplo de control de colisin de sprites: */
  if( x>=247 && x<=247+ancho_boton && y>=172 && y<=172+alto_boton )
    {
      DrawSprite_Mask( x, y, ancho_cursor, alto_cursor, 0, Cursor2, VGASEG );
      if( LeftPress() == 1 ) exitbutton = 1;
    }
  
  else
  DrawSprite_Mask( x, y, ancho_cursor, alto_cursor, 0, Cursor1, VGASEG );

  WaitVRetrace();
  GetSprite( x, y, ancho_cursor, alto_cursor, fondo, vscreen );
  DrawSprite( x, y, ancho_cursor, alto_cursor, fondo, VGASEG );
  
  /* salida de emergencia con tecla ESCAPE por si falla el ratn... */
   if( kbhit() ) 
    if( getch() == 27 ) exitbutton= 1;
 }

 MouseOff();
 DrawSprite( 247, 172, ancho_boton, alto_boton, Boton2, VGASEG );
 FadeOut();
 
 SetVideoMode( 3 );                       /* inicializar 80x25x16 (3h) */
 FreeVScreen( vscreen );                  /* liberar memoria asignada */
}

/*-----------------------------------------------------------------------*/
void LoadImage( char *nombre ) 
{
FILE *fp;
char Paleta[768];
char PaletaNegro[768];
int x, y;

 fp = fopen( nombre, "rb" );
  if( fp == NULL )
   {
     SetVideoMode(3);
     printf("\r\n\aError abriendo fichero %s...\r\n", nombre );
     exit(1);
   }
                                           
  for(x=0; x<768; x++ )
   PaletaNegro[x] = 0;
                                           /* leemos la paleta del SCR */
  for(x=0; x<768; x++ )
   Paleta[x] = fgetc(fp);

  SetPalette( PaletaNegro );               /* paleta de la imagen ---> DAC */

  for(y=0; y<200; y++ )                    /* leemos el bitmap del SCR */
   for(x=0; x<320; x++ )
    PutPixel( x, y, fgetc(fp), VGASEG );

  FadeIn( Paleta );
  fclose(fp);
}
