/*-----------------------------------------------------------------------
  Mouse.h                                                           [NoP]
  Pequea librera de uso del ratn para algunos ejemplos del curso.
 -----------------------------------------------------------------------*/


char MouseBitOn( unsigned int, unsigned int);
char MouseOn( void );
void MouseOff( void );
void ShowMouse( void );
void HideMouse( void );
void GetXY( int *, int *);
char LeftPress( void );

/*----------------------------------------------------------------
  Inicializa el driver del ratn y devuelve:
   -1 = Driver de ratn instalado (hay ratn).
    0 = Driver de ratn no instalado (no hay ratn).
 ----------------------------------------------------------------*/
char MouseOn( void ) 
{
asm {
    xor ax, ax
    int 0x33
    }

return ( _AL );
}

/*----------------------------------------------------------------
   Desinicializa el driver del ratn.
 ----------------------------------------------------------------*/
void MouseOff( void )
{
asm {
    mov ax, 2
    int 0x33
    mov cx, 0
    mov ax, 12
    int 0x33
    }
}

/*----------------------------------------------------------------
   Activa el cursor del ratn. Simplemente hace que el driver lo
   dibuje en pantalla. Si no se llama a esta funcin no aparece
   el cursor por defecto pero el ratn est activo y podemos leer
   sus coordenadas y estado "en la sombra".
 ----------------------------------------------------------------*/
void ShowMouse( void )
{
asm {
    mov ax, 1
    int 0x33
    }
}

/*----------------------------------------------------------------
   Esconde el cursor del ratn. Sigue estando activo y puede
   moverse, pero ya no aparece en pantalla.
 ----------------------------------------------------------------*/
void HideMouse( void )
{
asm {
    mov ax, 2
    int 0x33
    }
}

/*----------------------------------------------------------------
    Devuelve las coordenadas x e y del cursor del ratn.
    Las devuelve en formato 640x200 (hay que transformarlas).
 ----------------------------------------------------------------*/
void GetXY ( int *x , int *y )
{
asm {
    mov ax, 3
    int 0x33
    }
 *x     = _CX ;
 *y     = _DX ;
}

/*----------------------------------------------------------------
     Devuelve el estado del botn izquierdo del ratn:
       0 = Botn no pulsado.
       1 = Botn pulsado.
 ----------------------------------------------------------------*/
char LeftPress()
{
unsigned int boton;

asm {
    mov ax, 3
    int 0x33
    }
boton = _BX ;

return ( MouseBitOn(boton,1) );

}

/*----------------------------------------------------------------
     Devuelve el estado del bit consultado (devuelve 0  1).
  ----------------------------------------------------------------*/
char MouseBitOn( unsigned int num, unsigned int byt)
{

asm {
        mov ax , num
        and ax , byt
        cmp ax , 0

        jz zeromouse
    }
         return(1); 
zeromouse:;    
 return(0);
    }
