/*                                                                          
  Ŀ
   PVirtual.c                                                             
                                                                          
   Demostracin del uso de pantallas virtuales.                           
                                                                          
   Compilado con :  Borland C/C++ v3.1                                    
   Cdigo y texto:  [NoP] de Compiler SoftWare.                     
  1997 C.S.
*/

#include <stdio.h>                  /* funciones estndar Input/Output */
#include <stdlib.h>                 /* funcin exit() */
#include <dos.h>                    /* funcin pokeb(); */
#include <conio.h>                  /* funcin getch(); */
#include "libs\ints.h"              /* librera funciones varias int 10h */
#include "libs\mode13h.h"           /* librera funciones 320x200x256 */
#include "libs\palette.h"           /* librera funciones paleta */
#include "libs\sprites.h"           /* librera funciones sprites */
#include "libs\vscreen.h"           /* librera funciones pant. virtuales */

#include "graphics\acid.h"          /* bitmap de un acid y su paleta */

void LoadImage( char * );           /* carga de un fichero SCR */

char fondo[ancho_acid*alto_acid];
unsigned int bucle, x, y, xincr, yincr, vscreen;

/*  Funcin principal main()  */

void main( void )
{

 SetVideoMode( 3 );                       /* inicializar 80x25x16 (3h) */

 printf("PVIRTUAL.EXE\r\n");
 printf("\r\nEste ejemplo utiliza pantallas virtuales para almacenar el fondo y as\r\n");
 printf("borrar luego los sprites de la pantalla moviendo bloques de fondo sobre ellos.\r\n\n");
 printf("Programa:\r\n");
 printf("           1. Almacenar fondo en VScreen.\r\n");
 printf("           2. Volcar fondo desde Vscreen a VRAM.\r\n");
 printf("           3. Dibujar sprite en VRAM.\r\n");
 printf("           4. Borrar sprite moviendo un bloque de fondo\r\n");
 printf("              desde VScreen hasta VRAM.\r\n");
 printf("           5. Repetir desde 3). hasta pulsacin de tecla.\r\n\n");

 printf("Pulse cualquier tecla para realizar la prueba...");
 getch();
  
 vscreen = AllocateVScreen();              /* asignar pantalla virtual */
 if( vscreen == 0 )
  {
    SetVideoMode(3);
    printf("\a\r\nError liberando memoria para la VScreen.\r\n");
    return;
  }

 SetVideoMode( 0x13 );                    /* inicializar 320x200x256 (13h) */
 LoadImage("GRAPHICS\\IMAGE1.SCR");       /* cargamos la imagen de fondo */
 FlipVScreen( VGASEG, vscreen );          /* guardamos el fondo en vscreen */
  
 x = 120; y = 90; xincr = 2; yincr = -2;

 while( !kbhit() )
 {
  DrawSprite_Mask( x, y, ancho_acid, alto_acid, 0, Acid, VGASEG );

  WaitVRetrace();
  GetSprite( x, y, ancho_acid, alto_acid, fondo, vscreen );
  DrawSprite( x, y, ancho_acid, alto_acid, fondo, VGASEG );

  /* control de interacciones: movimiento del sprite */
   x = x + xincr;
   y = y + yincr;

  /* control de interacciones: choques con los bordes */
   if( x<15 || x>273 ) xincr = xincr*(-1) ;
   if( y<15 || y>142 ) yincr = yincr*(-1) ;
 }

 getch();                                 /* esperar a que pulse una tecla */
 SetVideoMode( 3 );                       /* inicializar 80x25x16 (3h) */
 FreeVScreen( vscreen );                  /* liberar memoria asignada */
}

/*-----------------------------------------------------------------------*/
void LoadImage( char *nombre ) 
{
FILE *fp;
char Paleta[768];
int x, y;

 fp = fopen( nombre, "rb" );
  if( fp == NULL )
   {
     SetVideoMode(3);
     printf("\r\n\aError abriendo fichero %s...\r\n", nombre );
     exit(1);
   }
                                           /* leemos la paleta del SCR */
  for(x=0; x<768; x++ )
   Paleta[x] = fgetc(fp);

  SetPalette( Paleta );                    /* paleta de la imagen ---> DAC */

  for(y=0; y<200; y++ )                    /* leemos el bitmap del SCR */
   for(x=0; x<320; x++ )
    PutPixel( x, y, fgetc(fp), VGASEG );

  fclose(fp);
}
